Bug 859357 - NFS over RDMA small block DIRECT_IO corruption
NFS over RDMA small block DIRECT_IO corruption
Status: CLOSED DUPLICATE of bug 857020
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel (Show other bugs)
6.5
Unspecified Unspecified
unspecified Severity unspecified
: rc
: ---
Assigned To: nfs-maint
Filesystem QE
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-09-21 05:52 EDT by Andrew Holway
Modified: 2013-12-20 07:58 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-12-20 07:58:00 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Andrew Holway 2012-09-21 05:52:36 EDT
Description of problem:

I have a Centos 6.2 server and Centos 6.2 client.

[root@store ~]# cat /etc/exports 
/dev/shm                10.149.0.0/16(rw,fsid=1,no_root_squash,insecure)    (I
have tried with non tempfs targets also)


[root@node001 ~]# cat /etc/fstab 
store.ibnet:/dev/shm    /mnt     nfs   rdma,port=2050,defaults 0 0


I wrote a little for loop one liner that dd'd the centos net install image to a
file called 'hello' then checksummed that file. Each iteration uses a different
block size.

Non DIRECT_IO seems to work fine. DIRECT_IO with 512byte, 1K and 2K block sizes
get borked.


Here we can see various block sizes doing exciting things to the data. :)

[root@node001 mnt]# for f in 32 64 128 256 512 1024 2048; do dd bs="$f"
if=hello of=hello2 iflag=direct && cat hello2 && echo -e "\n" && rm -f hello2
;done
42+1 records in
42+1 records out
1349 bytes (1.3 kB) copied, 0.00410677 s, 328 kB/s
01010101010101010101010101010101010101
01010101010101010101010101010101010101
01010101010101010101010101010101010101
01010101010101010101010101010101010101
010101010101010101010101010101010101101010101010101010101010101010100101010101010101010101010101010110101010101010101010101010101010010101010101010101010101010101011010101010101010101010101010101010101
01010101010101010101010101010101010101
01010101010101010101010101010101010101
01010101010101010101010101010101010101
010101010101010101010101010101010101001010101010101010101010101010101101010101010101010101010101010100101010101010101010101010101010110101010101010101010101010101010010101010101010101010101010101010101


21+1 records in
21+1 records out
1349 bytes (1.3 kB) copied, 0.00183851 s, 734 kB/s
01010101010101010101010101010101010101010101010101010101010101011010101010101
01010101010101010101010101010101010101010101010101101010101010101010101010101
01010101010101010101010101010101010110101010101010101010101010101010101010101
01010101010101010101011010101010101010101010101010101010101010101010101010101
010101011010101010101010101010101010101010101010101010101010101010101010010101010101
01010101010101010101010101010101010101010101010101001010101010101010101010101
01010101010101010101010101010101010100101010101010101010101010101010101010101
01010101010101010101010010101010101010101010101010101010101010101010101010101
0101010100101010101010101010101010101010101010101010101010101010101010101

10+1 records in
10+1 records out
1349 bytes (1.3 kB) copied, 0.00105593 s, 1.3 MB/s
0101010101010101010101010101010101010101010101010101010101010101010101
010101010101010101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
010101010101010101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
010101010101010101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
010101010101010101010101010101010101010101010101010101010101010101010101010101010101


5+1 records in
5+1 records out
1349 bytes (1.3 kB) copied, 0.000748207 s, 1.8 MB/s
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
01010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
01010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
01

2+1 records in
2+1 records out
1349 bytes (1.3 kB) copied, 0.000511325 s, 2.6 MB/s
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010100101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101


1+1 records in
1+1 records out
1349 bytes (1.3 kB) copied, 0.000440374 s, 3.1 MB/s
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
010101010101010101010101010101

0+1 records in
0+1 records out
1349 bytes (1.3 kB) copied, 0.000325736 s, 4.1 MB/s
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101
0101010101010101010101010101010101010101010101010101010101010101010101



Version-Release number of selected component (if applicable):

all


How reproducible:

please see description


Steps to Reproduce:
1.
2.
3.
  
Actual results:


Expected results:


Additional info:

it appears the RHEL6 kernels are lacking a couple patches that might
help with this....

5c635e09 RPCRDMA: Fix FRMR registration/invalidate handling.
9b78145c xprtrdma: Remove assumption that each segment is <= PAGE_SIZE
Comment 2 RHEL Product and Program Management 2012-12-14 03:14:17 EST
This request was not resolved in time for the current release.
Red Hat invites you to ask your support representative to
propose this request, if still desired, for consideration in
the next release of Red Hat Enterprise Linux.
Comment 6 Jeff Layton 2013-12-20 07:58:00 EST

*** This bug has been marked as a duplicate of bug 857020 ***

Note You need to log in before you can comment on or make changes to this bug.